SET SERVEROUTPUT ON
DECLARE
  jobId    BINARY_INTEGER;
  firstRun DATE;
BEGIN
  -- Start the job tomorrow at 2am
  firstRun := TO_DATE(TO_CHAR(SYSDATE+1,'DD-MON-YYYY')||' 02:00',
                      'DD-MON-YYYY HH24:MI');

  -- Submit the job, indicating it should repeat once a day
  dbms_job.submit(job       => jobId,
                  what      => 'moveBadXmlDocuments;',
                  next_date => firstRun,
                  interval  => 'SYSDATE + 1' /* Reschedule for 1 Day Later */
                 );
  dbms_output.put_line('Successfully submitted job. Job Id is '||jobId);
END;
