import oracle.xml.parser.schema.*;
import oracle.xml.parser.v2.*;

//  Hi,
//  There are two ways to do this:
//
//   1. Using programatic APIs
//   1.1 Build the XMLSchema object using the XSDBuilder.build(namespace,
//       system_id)
//   1.2 Get the XML Schema object using XSDBuilder.getObject()
//   1.3 Set the schema object in the parser (DOM or SAX) using
//       parser.setXMLSchema(Object)
//   1.4 Parse the document using parser.parse()
//
//2. Change the instance document (in this case wan.xsd)
//   2.1 Add the following attributes to the root element in wan.xsd
//      xmlns:xsi =  "http://www.w3.org/1999/XMLSchema/instance"
//      // Defines xsi prefix
//      xsi:schemaLocation = "namespace-of-wan
//      system-id-of-schema-to-be-used"
//      /* defines the mapping between a namespace and a schema definition
//      to be used */
//
//  The documentation is quite bad, and will be fixed in the next release.

public class SchemaExample {
  public static void main(String[] args) throws Exception {

     XSDBuilder xsd = new XSDBuilder();
     xsd.build("http://www.example.com/PO1","po.xsd");
     XMLSchema  sch = (XMLSchema)xsd.getObject();
     DOMParser  par = new DOMParser();
     par.setSchemaValidationMode(true);
     par.setPreserveWhitespace(true);
     par.setDebugMode(true);
     par.setErrorStream(System.out);
     par.setXMLSchema(sch);

  }
}
