import oracle.sql.CLOB;
import java.io.*;
import oracle.xml.parser.v2.*;
import java.net.URL;

public class XMLDocumentFromClob {

  public static XMLDocument read( CLOB theClob, URL baseURL, DTD theDTD )
  throws Exception {

    // Create an oracle.xml.parser.v2.DOMParser to parse the document.
    DOMParser theParser = new DOMParser();

    Reader in = theClob.getCharacterStream();


    // Set the base URL if provided to be used for reading DTD's
    if (baseURL != null) theParser.setBaseURL(baseURL);

    // Set the DTD to use if provided
    if (theDTD != null) theParser.setDoctype(theDTD);

    // Parse the document from the URL
    theParser.parse(in);
    in.close();

    // Get the parsed XML Document from the parser
    return theParser.getDocument();

  }

}