<!-- MarkcheapRedItemsOnSale.xsl: Adds <OnSale> to Red items under $20.00 -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <!-- Import the identity transformation. -->
  <xsl:import href="Identity.xsl"/>
  <!-- Strip text nodes that are all whitespace -->
  <xsl:strip-space elements="*"/>
  <!-- Indent the result -->
  <xsl:output indent="yes"/>
  <xsl:template match="Item[@Color='Red' and 20 > Price]">
    <xsl:copy>
      <!-- First copy Item's attributes -->
      <xsl:apply-templates select="@*"/>
      <!-- Then add a literal <OnSale> element -->
      <OnSale/>
      <!-- Then copy the rest of any children nodes -->
      <xsl:apply-templates select="node()"/>
    </xsl:copy>
  </xsl:template>
</xsl:stylesheet>