drop table city;
drop table state;
drop table country;

create table country( name varchar2(80), primary key (name));
create table state( name varchar2(80),
                    countryname varchar2(80),
                    primary key (name),
                    foreign key (countryname) references country);
create table city( name varchar2(80), statename varchar2(80),
                   primary key (name),
                    foreign key (statename) references state);
insert into country values ('USA');
insert into country values ('Italia');

insert into state values ('Piemonte','Italia');
insert into state values ('Umbria','Italia');
insert into state values ('Veneto','Italia');
insert into state values ('NV','USA');
insert into state values ('CA','USA');

insert into city values ('San Francisco','CA');
insert into city values ('Oakland','CA');
insert into city values ('Los Angeles','CA');
insert into city values ('Venezia','Veneto');
insert into city values ('Padova','Veneto');
insert into city values ('Asisi','Umbria');
insert into city values ('Torino','Piemonte');
insert into city values ('Las Vegas','NV');
insert into city values ('Reno','NV');

drop table visit;
drop table patient;
drop table doctor;
drop table facility;
CREATE TABLE facility (
 code    VARCHAR2(8) PRIMARY KEY,
 name    VARCHAR2(40),
 address VARCHAR2(40),
 city    VARCHAR2(40),
 CONSTRAINT city_pk2 FOREIGN KEY (city) REFERENCES city
);

insert into facility values 
 ( 'Bay03','Bayside Medical',
   '201 Oceanview Rd.',
   'San Francisco');

insert into facility values 
 ( 'French44','Downtown French Campus',
   '11 Battery Street',
   'San Francisco');

CREATE TABLE doctor (
  id VARCHAR2(10) PRIMARY KEY,
  firstname  VARCHAR2(40),
  lastname   VARCHAR2(40),
  homeoffice VARCHAR2(40),
  CONSTRAINT homeoffice_fk FOREIGN KEY (homeoffice) REFERENCES facility
);

insert into doctor values
('bblatt','Bruce','Blatt', 'Bay03');

insert into doctor values
('krhymes','Kathryn','Rhymes', 'Bay03');

insert into doctor values
('bproto','Bryan','Proto', 'French44');

CREATE TABLE patient (
  id NUMBER PRIMARY KEY,
  firstname VARCHAR2(40),
  lastname  VARCHAR2(40)
);

insert into patient values 
( 2099344, 'Laurel','Birch');

insert into patient values 
( 6257889, 'Rory','Cyclone');

CREATE TABLE visit (
  id         NUMBER,
  visitdate  DATE,
  patientid  NUMBER,
  facilityid VARCHAR2(8),
  doctorid   VARCHAR2(10),
  CONSTRAINT visit_pk    PRIMARY KEY (id),
  CONSTRAINT patient_fk  FOREIGN KEY (patientid)  REFERENCES patient,
  CONSTRAINT facility_fk FOREIGN KEY (facilityid) REFERENCES facility,
  CONSTRAINT doctor_fk   FOREIGN KEY (doctorid)   REFERENCES doctor
);

insert into visit values
(198554, SYSDATE, 2099344, 'Bay03', 'bproto');
insert into visit values
(197111, SYSDATE-11, 2099344, 'French44', 'bproto');
insert into visit values
(196223, SYSDATE-24, 2099344, 'Bay03', 'krhymes');
 
insert into visit values
(197355, SYSDATE-7, 6257889, 'Bay03', 'bblatt');
insert into visit values
(197112, SYSDATE-11, 6257889, 'French44', 'krhymes');
insert into visit values
(194433, SYSDATE-48, 6257889, 'Bay03', 'krhymes');
commit;
