/*@lineinfo:filename=CreditAuthorization*//*@lineinfo:user-code*//*@lineinfo:1^1*/import java.sql.*;
import oracle.xml.parser.v2.XMLElement;
import org.w3c.dom.Document;
import sqlj.runtime.ref.DefaultContext;
import Examples;

public class CreditAuthorization {

  public static long newRequest(Document authDoc)
  throws Exception {

    // Connect to the Database
    DefaultContext.setDefaultContext(new DefaultContext(Examples.getConnection()));

    XMLElement req = (XMLElement)authDoc.getDocumentElement();

    // Get String values of important elements in XML Document
    // in preparation for Insert
    String cardNumber  = req.valueOf("CardNumber");
    String expiration  = req.valueOf("Expiration");
    String amount      = req.valueOf("Amount");
    String currency    = req.valueOf("Amount/@Currency");
    String merchantId  = req.valueOf("MerchantId");
    String requestDate = req.valueOf("Date");

    // Split up the MM/YYYY expiration value for insert
    String expMonth    = expiration.substring(0,2);
    String expYear     = expiration.substring(3);

    // Request Id assigned to this request during the insert
    String requestId;

    // Insert the information content into appropriate
    // database columns, using a Sequence for generating
    // a unique request Id.

    /*@lineinfo:generated-code*//*@lineinfo:37^5*/

//  ************************************************************
//  #sql { BEGIN
//            INSERT INTO authorization_request ( request_id,
//                                                request_date,
//                                                card_number,
//                                                exp_month,
//                                                exp_year,
//                                                amount,
//                                                currency,
//                                                merchant_id )
//            VALUES(authorization_request_seq.nextval,
//                   TO_DATE(:requestDate,'DD-MM-YYYY HH24:MI:SS'),
//                   :cardNumber,
//                   :expMonth,
//                   :expYear,
//                   :amount,
//                   :currency,
//                   :merchantId )
//            RETURNING request_id INTO :requestId;
//            COMMIT;
//          END;
//           };
//  ************************************************************

{
  sqlj.runtime.ConnectionContext __sJT_connCtx = sqlj.runtime.ref.DefaultContext.getDefaultContext();
  if (__sJT_connCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_CONN_CTX();
  sqlj.runtime.ExecutionContext __sJT_execCtx = __sJT_connCtx.getExecutionContext();
  if (__sJT_execCtx == null) sqlj.runtime.error.RuntimeRefErrors.raise_NULL_EXEC_CTX();
  String __sJT_1 = requestDate;
  String __sJT_2 = cardNumber;
  String __sJT_3 = expMonth;
  String __sJT_4 = expYear;
  String __sJT_5 = amount;
  String __sJT_6 = currency;
  String __sJT_7 = merchantId;
  synchronized (__sJT_execCtx) {
    sqlj.runtime.profile.RTStatement __sJT_stmt = __sJT_execCtx.registerStatement(__sJT_connCtx, CreditAuthorization_SJProfileKeys.getKey(0), 0);
    try 
    {
      __sJT_stmt.setString(1, __sJT_1);
      __sJT_stmt.setString(2, __sJT_2);
      __sJT_stmt.setString(3, __sJT_3);
      __sJT_stmt.setString(4, __sJT_4);
      __sJT_stmt.setString(5, __sJT_5);
      __sJT_stmt.setString(6, __sJT_6);
      __sJT_stmt.setString(7, __sJT_7);
      __sJT_execCtx.executeUpdate();
      requestId = __sJT_stmt.getString(8);
    }
    finally 
    {
      __sJT_execCtx.releaseStatement();
    }
  }
}


//  ************************************************************

/*@lineinfo:user-code*//*@lineinfo:57^9*/
    return Long.parseLong(requestId);
  }
}/*@lineinfo:generated-code*/class CreditAuthorization_SJProfileKeys 
{
  private static CreditAuthorization_SJProfileKeys inst = null;
  public static java.lang.Object getKey(int keyNum) 
    throws java.sql.SQLException 
  {
    if (inst == null)
    {
      inst = new CreditAuthorization_SJProfileKeys();
    }
    return inst.keys[keyNum];
  }
  private final sqlj.runtime.profile.Loader loader = sqlj.runtime.RuntimeContext.getRuntime().getLoaderForClass(getClass());
  private java.lang.Object[] keys;
  private CreditAuthorization_SJProfileKeys() 
    throws java.sql.SQLException 
  {
    keys = new java.lang.Object[1];
    keys[0] = sqlj.runtime.ref.DefaultContext.getProfileKey(loader, "CreditAuthorization_SJProfile0");
  }
}
 
