CREATE TRIGGER department_ins
INSTEAD OF INSERT ON department
FOR EACH ROW 
DECLARE
  emps emp_list; -- Holds a list of Employees
  emp  emp_t;    -- Holds a single Employee
BEGIN
  -- Insert the master
  INSERT INTO dept( deptno, dname ) 
  VALUES (:new.deptno, :new.dname );

  -- Insert the details, using value of :new.deptno as the DEPTNO
  emps := :new.employees;
  FOR i IN 1..emps.COUNT LOOP
    emp := emps(i);
    INSERT INTO emp(deptno, empno, ename, sal)
    VALUES (:new.deptno, emp.empno, emp.ename, emp.sal);
  END LOOP;
END;
