<!-- ColumnOverrides.xsl : handle one-off formatting special cases -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:include href="UtilText.xsl"/>
  <!-- Anywhere a Posting appears in a <ROW>, Format it as Code -->
  <xsl:template match="ROW/Posting">
    <td>
      <span class="date">
        <xsl:text>Posted </xsl:text>
        <xsl:value-of select="../H_Posted_On"/>
      </span>
      <hr/>
      <span class="code">
        <xsl:call-template name="br-replace">
          <xsl:with-param name="text">
            <xsl:call-template name="sp-replace">
              <xsl:with-param name="text" select="."/>
            </xsl:call-template>
          </xsl:with-param>
        </xsl:call-template>
      </span>
    </td>
  </xsl:template>
  <!-- Anywhere a Topic appears in a <ROW>, link to drill-down -->
  <xsl:template match="ROW/Topic">
    <td>
      <a href="TopicPostings.xsql?id={../H_ID}">
        <xsl:apply-templates/>
      </a>
    </td>
  </xsl:template>
  <!-- Anywhere a Forum appears in a <ROW>, link to drill-down -->
  <xsl:template match="ROW/Forum">
    <td>
      <a href="ForumTopics.xsql?id={../H_ID}">
        <xsl:apply-templates/>
      </a>
    </td>
  </xsl:template>
</xsl:stylesheet>
